#include <extUtil.h>
/***********************************************************************/
/*  sucht Nullstelle (x fuer y=0) einer Funktion nach regula falsi     */
/*  xmin,xmax: Startwerte fuer x                                       */
/*  x0     : Wert bei der die funktion eine Nullstelle hat             */
/*  abw    : zu minimierende Groesse (y)                               */
/*  funktion(): Funktion fuer die die Nullstelle berechnet werden soll */
/***********************************************************************/

/***************  FUNKTION *******************************/
/*                                                       */
/* double funktion( double x0 )                            */
/*  return abw                                           */
/* (siehe unter cc/bsp)                                  */
/*********************************************************/




double nullstelle(double xmin, double xmax, double funktion(double), double *result )
{
  int   nx,in ;
  double x0,y0,y1,en,abw;

      nx=30;
      in=1;
      x0=xmin;

      abw=funktion(x0);

      y0=abw;

m500:;
      x0=xmax;

      abw=funktion(x0);

      y1=abw;
      if (y0==y1) goto m600;
      en=(xmax-xmin)*y1/(y1-y0);
      xmin=xmax;
      y0=y1;
      xmax=xmax-en;
      if ( abs(en) <= .00001 ) goto m300;
      if (in < nx)
      {
        in=in+1;
        goto m500;
      }
      else
        goto m600;
m600:;
      printf ("schlechte Startwerte\n");
m300:;
      *result=x0;
      return(abw );
}





