#include <extUtil.h>

/*
 on [Enter] return 1, otherwise return 0
*/
int parser( unsigned char gkey, unsigned char *record )
{
  int j;                                             // local looping index
  static int i={0};                                  // count of keystrokes in current command
  static unsigned char  keystroke[MAX_LINE_LENGTH];  // the command

  if (gkey == (unsigned char)0xff0d)      // [Enter]
  {
    // set the parser output
    strcpy( record, keystroke); 
    // reinitialize the data and start a new line
    for (j=0; j<MAX_LINE_LENGTH; j++) 
		keystroke[j]=(unsigned char)0x20; // [Space]
    printf("\n");
    i=0;
    return(1);
  } else {
    if (gkey == (unsigned char)0xff08)    // [Backspace]
    {
	  printf("[<-]\n");
	  if (i>0){
		  i--;
		  for (j=0; j<i; j++)
              printf("%c",keystroke[j]);
	  }
    } else {
      keystroke[i] = gkey;
	  printf("%c",gkey);
      i++;
    }
    keystroke[i]=(unsigned char)0x20;     // [Space]
  }
  return(0);
}

