
/*---------------------------------------------------------------------*/
/* liest eine Zeile (bis \n) aus dem Speicher.                         */
/*                                                                     */
/* bufstart: Laufende Nummer des ersten zu lesenden Elementes.         */
/* bufsize : Anzahl Elemente im Speicher, beginnend bei inputdata.     */
/* buffer  : Pointer zum Anfang der gelesenen Zeile                    */
/* bufend  : Rueckgabewert, Laufende Nr. des 1. Elementes der folgenden*/
/*           Zeile.                                                    */
/*---------------------------------------------------------------------*/
#include <extUtil.h>


int getrecord (int bufstart, int bufsize, unsigned char *inputdata, unsigned char *buffer)
{
    int     bufend;

    bufend = bufstart;

    while ((bufend<bufsize) && (inputdata[bufend]!='\n'))
      { bufend++; }

    if ((bufend-bufstart) >= MAX_LINE_LENGTH )
    {
      printf("\n fehler in getrecord, recordlaenge:%d",(bufend-bufstart));
      exit (-1);
    }
    if (bufend >= bufsize)
    {
      printf("\n getrecord: letzter record gelesen, recordlaenge: %d \n",(bufend-bufstart));
      return (-1);
    }

    memcpy (buffer, &inputdata[bufstart], bufend-bufstart);
            buffer[bufend-bufstart] = 0;

    return (bufend);                           /* Return the length of the line read           */
}

