/* ---------------------------------------------------------------- */
/* interpoliert linear zwischen x(i) und x(i-1)                     */
/* es wird auch  extrapoliert.                                      */
/* x0: Stelle auf die interpoliert wird                             */
/* y0: Rueckgabewert                                                */
/* ---------------------------------------------------------------- */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>

double interpol(double *x, double *y, int n, double x0 )
{
      int       imin, imax;
      double     y0;
      double     dx,dy,dx0;

      /* finde den index des punktes mit dem kleinsten +x_abstand zu xo */

      n--;
      if (x0 < x[0])
      {
        imin = 0;
        imax = 1;
      }
      else if (x0 > x[n])
      {
        imin = n-1;
        imax = n;
      }
      else
      {
        imax=0;
        while (x[imax]<x0) imax++;
        imin=imax-1;
      }


      /*     *** lineare interpolation   ************    */

      dx=x[imax]-x[imin];
      dy=y[imax]-y[imin];
      dx0=x0-x[imin];
      y0=y[imin]+dx0*dy/dx;

      return(y0);
}

